/* TextDemo.java is a 1.4 application that requires no other files. */
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ChatPanel extends JPanel {
    EventHandler listener;
    private GameBoard board = null;
    protected JTextField textField;
    protected JTextArea textArea;
    private final static String newline = "\n";

    public ChatPanel(EventHandler eventlistener) {
        super(new GridBagLayout());

	this.listener = eventlistener;

	textArea = new JTextArea(5, 20);
	textArea.setBackground(ConnectN.TEXTAREACOLOR);
	textArea.setLineWrap(true);
	textArea.setEditable(false);
	textField = new JTextField(20);
	textField.setBackground(ConnectN.TEXTAREACOLOR);
	textField.addActionListener(listener);


        JScrollPane scrollPane = new JScrollPane(textArea,
                                       JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                                       JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scrollPane.setBackground(ConnectN.GUICOLOR);

        //Add Components to this panel.
        GridBagConstraints c = new GridBagConstraints();
        c.gridwidth = GridBagConstraints.REMAINDER;
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1.0;
        c.weighty = 1.0;
        this.add(scrollPane, c);

        c.fill = GridBagConstraints.HORIZONTAL;
        this.add(textField, c);
    }

    public void updateText(String line) {
	line = line + newline;

	textArea.append(line);
	textArea.setCaretPosition(textArea.getDocument().getLength());
	textField.setText("");
    }

    public void clearText() {
	this.textArea.setText("");
    }
}
