/**
 * MenuComponent.java
 * This is a component to go into the window.
 * This component builds the menu bar across the top of the window.
 **/
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class MenuComponent {
    private JMenuBar menuBar;
    private JMenu menu;
    private JMenu newMenu;
    private JMenuItem newNet;
    private JMenuItem newLoc;
    private JMenuItem saveItem;
    private JMenuItem loadItem;
    private JMenuItem exitItem;
    private JMenuItem statsItem;
    private EventHandler listener;

	public MenuComponent(EventHandler eventlistener)	    
	{
	    this.listener = eventlistener;
	}

	public JMenuBar createMenuBar()
	{

	    //Create the menu bar.
	    menuBar = new JMenuBar();
		menuBar.setBackground(ConnectN.GUICOLOR);


	    //Build the first menu.
	    menu = new JMenu("File");
		menu.setBackground(ConnectN.GUICOLOR);
	    menuBar.add(menu);
	    
	    // This is where the menu items go
	    // This is the format to make menu items
	    //menuItem = new JMenuItem("A text-only menu item");
	    //menuItem.getAccessibleContext().setAccessibleDescription(
	    // "This doesn't really do anything");
	    //menu.add(menuItem);

	newMenu = new JMenu("New Game");
	newMenu.setBackground(ConnectN.GUICOLOR);
	newMenu.getAccessibleContext().setAccessibleDescription(
		"This starts a new Game");
	newMenu.addActionListener(listener);
	menu.add(newMenu);

	statsItem = new JMenuItem("High Scores");
	statsItem.setBackground(ConnectN.GUICOLOR);
	statsItem.getAccessibleContext().setAccessibleDescription(
					 "This brings up the stats window");
	statsItem.addActionListener(listener);
	menu.add(statsItem);

	newNet = new JMenuItem("Network Game");
	newNet.setBackground(ConnectN.GUICOLOR);
	newNet.getAccessibleContext().setAccessibleDescription(
	       "This starts a new Network Game.");
	newNet.addActionListener(listener);
	newMenu.add(newNet);
	
	newLoc = new JMenuItem("Local Game");
	newLoc.setBackground(ConnectN.GUICOLOR);
	newLoc.getAccessibleContext().setAccessibleDescription(
	       "This starts a new Local Game.");
	newLoc.addActionListener(listener);
	newMenu.add(newLoc);

	saveItem = new JMenuItem("Save Game");
	saveItem.setBackground(ConnectN.GUICOLOR);
	saveItem.getAccessibleContext().setAccessibleDescription(
									   "This saves the game in progress");
	saveItem.addActionListener(listener);
	menu.add(saveItem);

	loadItem = new JMenuItem("Load Game");
	loadItem.setBackground(ConnectN.GUICOLOR);
	loadItem.getAccessibleContext().setAccessibleDescription(
									  "This loads a new single player game");
	loadItem.addActionListener(listener);
	menu.add(loadItem);

	exitItem = new JMenuItem("Exit");
	exitItem.setBackground(ConnectN.GUICOLOR);
	exitItem.getAccessibleContext().setAccessibleDescription(
                "This exits the game");
	exitItem.addActionListener(listener);
	menu.add(exitItem);

	return(menuBar);

	}

    /**
     * method used to enable disable load and save capabilities based on game
     * states. 
     **/
     public JMenuBar updateMenuBar(boolean save, boolean load, boolean stat) {
	 saveItem.setEnabled(save);
	 loadItem.setEnabled(load);
	 statsItem.setEnabled(stat);
	 return menuBar;
     }
    
}	
